addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.digwallanim = $ or 0
		if player.digwallanim --Digging wall anim
			player.digwallanim = $ - 1
			player.nocrouch = 2
			player.deggin2 = true
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 2
			ghost.blendmode = AST_OVERLAY
			ghost.state = S_PLAY_EDGE
			if (leveltime&10) <= 4
				ghost.mirrored = true
			else
				ghost.mirrored = false
			end
			local addrad = (15*FRACUNIT)-(player.digwallanim*FRACUNIT)
			local addx = P_ReturnThrustX(nil, player.drawangle, addrad)
			local addy = P_ReturnThrustY(nil, player.drawangle, addrad)
			P_TeleportMove(ghost, player.mo.x+addx, player.mo.y+addy, player.mo.z)
			player.deleteghost = ghost
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.powers[pw_flashing] = 1
			if not S_SoundPlaying(player.mo, sfx_mindig)
				S_StartSound(player.mo, sfx_mindig)
			end
			player.pflags = $|PF_FULLSTASIS
			if (leveltime&10) <= 4
				player.mo.mirrored = true
			else
				player.mo.mirrored = false
			end
			player.mo.flags2 = $|MF2_DONTDRAW
			if player.ghbag
				local levang = (player.realtime%360)*ANG1
				for i = 1, player.ghbag
					local addr = FixedMul(player.mo.radius/8, cos(levang))
					
					local ghost = P_SpawnGhostMobj(ghost)
					ghost.target = ghost
					ghost.frame = $&~FF_TRANSMASK
					ghost.frame = $|tr_trans90<<FF_TRANSSHIFT
					if player.ghbag > 1
						if i&1
							ghost.spritexoffset = addr
						else
							ghost.spritexoffset = -addr
						end
					end
					ghost.auragh = true
					ghost.colorized = true
					ghost.blendmode = AST_ADD
					ghost.fuse = 2
				end
			end
		else
			if player.deggin2
			and player.gotodig
				if player.deleteghost and player.deleteghost.valid
					P_KillMobj(player.deleteghost)
				end
				player.mo.flags2 = $ & ~MF2_DONTDRAW
				player.mo.mirrored = false
				player.drawangle = $+ANGLE_180
				player.mo.angle = player.drawangle
				player.pflags = $|PF_JUMPED
				player.pflags = $ & ~PF_THOKKED
				player.nocrouch = 5
				P_TeleportMove(player.mo, player.gotodig.x, player.gotodig.y, player.gotodig.z)
				local dig = P_SpawnMobjFromMobj(player.mo, P_ReturnThrustX(nil, player.drawangle, player.mo.radius-FRACUNIT), 
					P_ReturnThrustY(nil, player.drawangle, player.mo.radius-FRACUNIT), 
					player.mo.height/2, MT_MINUSDIRT)
				dig.flags = $|MF_NOGRAVITY
				dig.renderflags = $|RF_PAPERSPRITE
				dig.angle = player.drawangle+ANGLE_90
				S_StartSound(player.mo, sfx_crumbl)
			end
			player.deggin2 = false
		end
	end
end)