addHook("PlayerThink", function(player) //Fix every mistake with ceiling check
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		local dospeed = player.runspeed
		if (player.mo.eflags & MFE_UNDERWATER)
			dospeed = $>>1
		end
		local runspeed = player.speed >= dospeed
		if (runspeed or (player.powers[pw_super])) --Do cel. run
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if ((P_MobjFlip(player.mo) == 1 and daheight>=dacel)
			or (P_MobjFlip(player.mo) == -1 and daheight<=dacel))
			and not player.dotheflip
				local reallyflip = true
				if player.mo.subsector
				and player.mo.subsector.sector
				and ((P_MobjFlip(player.mo) == 1 and daheight >= player.mo.subsector.sector.ceilingheight)
				or (P_MobjFlip(player.mo) == -1 and daheight >= player.mo.subsector.sector.floorheight))
				and ((P_MobjFlip(player.mo) == 1 and player.mo.subsector.sector.ceilingpic == "F_SKY1")
				or (P_MobjFlip(player.mo) == -1 and player.mo.subsector.sector.floorpic == "F_SKY1"))
					reallyflip = false
				end
				if reallyflip
				and player.cmd.buttons & BT_JUMP
					player.pflags = $|PF_JUMPSTASIS
					player.pflags = $&~(PF_JUMPED|PF_THOKKED|PF_SPINNING|PF_STARTJUMP|PF_NOJUMPDAMAGE)
					player.powers[pw_gravityboots] = 3 //Who even uses these?
					player.dotheflip = true
					player.mo.state = S_PLAY_RUN
					S_StartSound(player.mo, sfx_cdfm50)
				end
			end
		else --Do cel. cling
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if ((P_MobjFlip(player.mo) == 1 and daheight>=dacel)
			or (P_MobjFlip(player.mo) == -1 and daheight<=dacel))
			and not player.dotheflip
			and not player.celcling
				local reallyflip = true
				if player.mo.subsector
				and player.mo.subsector.sector
				and ((P_MobjFlip(player.mo) == 1 and daheight >= player.mo.subsector.sector.ceilingheight)
				or (P_MobjFlip(player.mo) == -1 and daheight >= player.mo.subsector.sector.floorheight))
				and ((P_MobjFlip(player.mo) == 1 and player.mo.subsector.sector.ceilingpic == "F_SKY1")
				or (P_MobjFlip(player.mo) == -1 and player.mo.subsector.sector.floorpic == "F_SKY1"))
					reallyflip = false
				end
				if reallyflip
				and player.cmd.buttons & BT_JUMP
					player.pflags = $|PF_STASIS|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
					player.mo.state = S_PLAY_RIDE		
					player.celcling = true
					player.mo.momx = $/10*9
					player.mo.momy = $/10*9
					S_StartSound(player.mo, sfx_cdfm51)
					P_SetObjectMomZ(player.mo, FRACUNIT, true)
				end
			end
		end
		if player.celcling --Maintain ceiling cling.
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if ((P_MobjFlip(player.mo) == 1 and daheight>=dacel)
			or (P_MobjFlip(player.mo) == -1 and daheight<=dacel))
			and not player.dotheflip
				local reallyflip = true
				if player.mo.subsector
				and player.mo.subsector.sector
				and ((P_MobjFlip(player.mo) == 1 and daheight >= player.mo.subsector.sector.ceilingheight)
				or (P_MobjFlip(player.mo) == -1 and daheight >= player.mo.subsector.sector.floorheight))
				and ((P_MobjFlip(player.mo) == 1 and player.mo.subsector.sector.ceilingpic == "F_SKY1")
				or (P_MobjFlip(player.mo) == -1 and player.mo.subsector.sector.floorpic == "F_SKY1"))
					reallyflip = false
				end
				if reallyflip
					if player.cmd.buttons & BT_JUMP
						player.pflags = $|PF_STASIS|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
						player.mo.state = S_PLAY_RIDE
						player.celcling = true
						player.mo.momx = $/10*9
						player.mo.momy = $/10*9
						P_SetObjectMomZ(player.mo, FRACUNIT, true)
					end
				else
					player.pflags = $|PF_STASIS|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
					player.mo.state = S_PLAY_FALL
					player.celcling = false
					P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,-FRACUNIT), false)
				end
			else
				player.pflags = $|PF_STASIS|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
				player.mo.state = S_PLAY_FALL
				player.celcling = false
				P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,-FRACUNIT), false)
			end
			if not (player.cmd.buttons & BT_JUMP)
			and player.clingjump
				player.pflags = $|PF_STASIS|PF_JUMPED|PF_NOJUMPDAMAGE|PF_THOKKED
				player.mo.state = S_PLAY_FALL
				player.celcling = false
				P_SetObjectMomZ(player.mo, FixedMul(player.mo.scale,-FRACUNIT), false)
			end
		end
		if player.cmd.buttons & BT_JUMP
			player.clingjump = true
		else
			player.clingjump = false
		end
		
		if P_IsObjectOnGround(player.mo) --Maintain Ceiling run.
			if player.dotheflip
			and (runspeed or (player.powers[pw_super]))
				player.powers[pw_gravityboots] = 3
			end
		end
		if player.dotheflip
		and not player.powers[pw_gravityboots]
			player.dotheflip = false
			player.mo.rollangle = ANGLE_180 + P_RandomRange(-5, 5)*ANG1
			player.rollback = true
		end
		if player.rollback
			local diff = -player.mo.rollangle
			local factor = 8
			if player.panim == PA_DASH
			or player.panim == PA_ROLL
			or player.panim == PA_SPRING
			or player.panim == PA_FALL
			or player.panim == PA_RIDE
			or player.panim == PA_JUMP
				factor = 2
			end
			if diff > ANGLE_180
				diff = InvAngle(InvAngle($)/factor)
			else
				diff = $/factor
			end
			player.mo.rollangle = $+diff
			if abs(player.mo.rollangle) <= ANG1
				player.mo.rollangle = 0
				player.rollback = false
			end
		end
	end
end)