//The commands are for the Partnered` Up thingies.
freeslot("sfx_spdhck")

freeslot("MT_CYAURA", "S_CYAURA")

mobjinfo[MT_CYAURA] = {
	doomednum = -1,
	spawnstate = S_NULL,
	spawnhealth = 1,
	speed = FRACUNIT*60,
	radius = 10*FRACUNIT,
	height = 10*FRACUNIT,
	dispoffset = 0,
	reactiontime = 5,
	mass = 100,
	damage = 1,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

states[S_CYAURA] = {SPR_NULL, A|FF_FULLBRIGHT, 2, nil, 1, 0, S_NULL}

rawset(_G, "SNEW_Cyaura", function(player, colorr)
	local aura = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
	aura.target = player.mo
	aura.tracer = player.mo
	aura.state = S_CYAURA
	aura.skin = player.mo.skin
	aura.color = colorr
	aura.sprite = player.mo.sprite
	aura.sprite2 = player.mo.sprite2
	aura.spriteyscale = FRACUNIT + FRACUNIT/10
	aura.spritexscale = FRACUNIT + FRACUNIT/10
	aura.spriteyoffset = player.mo.spriteyoffset+(-FRACUNIT/2*5)
	aura.spritexoffset = player.mo.spritexoffset
	aura.rollangle = player.mo.rollangle
	aura.fuse = 2
	aura.colorized = true
	aura.aura = true
	return aura
end)

rawset(_G, "P_JumpTo", function(mo, fx, fy, fz, sped, addques) --A very useful command honestly.
	if mo.valid
		local flyto = P_AproxDistance(P_AproxDistance(fx - mo.x, fy - mo.y), fz - mo.z)
		if flyto < 1
			flyto = 1
		end
		local anglesucc = R_PointToAngle2(mo.x, mo.y, fx, fy)
		
		if addques
			mo.momx = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = $ + FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		else
			mo.momx = FixedMul(mo.scale,FixedMul(FixedDiv(fx - mo.x, flyto), sped))
			mo.momy = FixedMul(mo.scale,FixedMul(FixedDiv(fy - mo.y, flyto), sped))
			mo.momz = FixedMul(mo.scale,FixedMul(FixedDiv(fz - mo.z, flyto), sped)/5*3)
		end	
	end	
end) 