//Of course a character in the "new" series wouldn`t be in it without something with ceilings.

local function CanUnflip(player) --False - unflip, True - stay flipped.
	if player.dotheflip
		if player.pflags & PF_JUMPED
			if not player.dontunflip
				return true
			end
		else
			if not player.unfliptrue
				return true
			end
		end
	end
	return false
end

addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "recenttails"
		if player.powers[pw_tailsfly] --Code from L.E. Knux be like:
			local daheight = player.mo.z+player.mo.height
			local dacel = player.mo.ceilingz
			if P_MobjFlip(player.mo) == 1
				daheight = player.mo.z+player.mo.height
				dacel = player.mo.ceilingz
			else
				daheight = player.mo.z
				dacel = player.mo.floorz
			end
			if ((P_MobjFlip(player.mo) == 1 and daheight>=dacel)
			or (P_MobjFlip(player.mo) == -1 and daheight<=dacel))
			and not player.dotheflip
				local reallyflip = true
				if player.mo.subsector
				and player.mo.subsector.sector
				and ((P_MobjFlip(player.mo) == 1 and daheight >= player.mo.subsector.sector.ceilingheight)
				or (P_MobjFlip(player.mo) == -1 and daheight >= player.mo.subsector.sector.floorheight))
				and ((P_MobjFlip(player.mo) == 1 and player.mo.subsector.sector.ceilingpic == "F_SKY1")
				or (P_MobjFlip(player.mo) == -1 and player.mo.subsector.sector.floorpic == "F_SKY1"))
					reallyflip = false
				end
				if reallyflip
					player.pflags = $|PF_JUMPSTASIS
					player.powers[pw_gravityboots] = 3 //Who even uses these?
					player.dotheflip = true
				end
			end
		end
		if P_IsObjectOnGround(player.mo)
			if player.dotheflip
				player.powers[pw_gravityboots] = 3
			end
		end
		if player.dotheflip
		and not player.powers[pw_gravityboots]
			player.dotheflip = false
			player.mo.rollangle = ANGLE_180 + P_RandomRange(-5, 5)*ANG1
			player.rollback = true
		end
		if player.rollback
			local diff = -player.mo.rollangle
			local factor = 8
			if player.panim == PA_DASH
			or player.panim == PA_ROLL
			or player.panim == PA_SPRING
			or player.panim == PA_FALL
			or player.panim == PA_RIDE
			or player.panim == PA_JUMP
				factor = 2
			end
			if diff > ANGLE_180
				diff = InvAngle(InvAngle($)/factor)
			else
				diff = $/factor
			end
			player.mo.rollangle = $+diff
			if abs(player.mo.rollangle) <= ANG1
				player.mo.rollangle = 0
				player.rollback = false
			end
		end
	end
end)