local function AcceptThose(mo)
	if TN_EnemyCarry[mo.type]
	and TN_EnemyCarry[mo.type].type
	and TN_EnemyCarry[mo.type].type == "nopick" --No picking up these little shits
		return false
	end
	if TN_EnemyCarry[mo.type] --If in list
	and TN_EnemyCarry[mo.type].type
	and TN_EnemyCarry[mo.type].type != "nopick"
		return true
	end
	if (mo.flags & MF_BOSS) --If doesnt have these flags you gotta have MF_SHOOTABLE
		return false
	end
	if (mo.flags & (MF_ENEMY|MF_MONITOR|MF_MISSILE)) --If not in list then if has these flags
		return true
	end
	if (mo.flags & MF_SHOOTABLE) --If doesnt have these flags you gotta have MF_SHOOTABLE
		return true
	end
	return false --Everything failed.
end

local function SpawnVortex(player, ass) --Visual stuff.
	for f = 1, ass
		local sz = (-300*FRACUNIT)*P_MobjFlip(player.mo)
		if P_MobjFlip(player.mo) == 1
			if player.mo.z+sz < player.mo.floorz
				sz = (player.mo.floorz+5*FRACUNIT)-player.mo.z
			end
		else
			if (player.mo.z+player.mo.height)+sz > player.mo.ceilingz
				sz = (player.mo.ceilingz-5*FRACUNIT)-(player.mo.z+player.mo.height)
			end
		end
		local addz = ((sz/12)*f)*P_MobjFlip(player.mo)
		/*for h = 1, 12
			local addr = 0
			local bruh = 5
			local ff = f-bruh
			if f >= bruh --I spent atleast a HOUR for this formula
				addr = (ff*(10*(ff/(bruh/2))))*FRACUNIT
			end
			local rana = ((leveltime%360)*ANG2)
			local fa = (((360/12)*h)*ANG1) + f*ANG2
			local px = 45*FixedMul(player.mo.scale, cos(rana+fa)) + P_ReturnThrustX(nil, rana+fa, addr)
			local py = 45*FixedMul(player.mo.scale, sin(rana+fa)) + P_ReturnThrustY(nil, rana+fa, addr)
			
			local speedang = f*(ANG1*18)
			local axe = FixedMul(-player.speed*5, cos(-ANGLE_90+speedang))
			local speedmom = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			local ax = P_ReturnThrustX(nil, speedmom, axe)
			local ay = P_ReturnThrustY(nil, speedmom, axe)
			if not player.speed
				ax = 0
				ay = 0
			end
			
			local layer = P_SpawnMobjFromMobj(player.mo, px+ax, py+ay, addz, MT_DUSTLAYER)
			layer.momz = (-5*player.mo.scale)*P_MobjFlip(player.mo)
			layer.angle = R_PointToAngle2(layer.x, layer.y, player.mo.x, player.mo.y)+ANGLE_90
			layer.spriteyscale = FRACUNIT/3
			layer.state = $+2
			layer.tics = 1
			layer.fuse = 3
		end*/
		local column = 12
		for i = 1, column
			local rana = ((leveltime%360)*ANG2) + (((360/column)*i)*ANG1)
			local addr = 0
			local bruh = 5
			if f >= bruh --I spent atleast a HOUR for this formula
				local ff = f-bruh
				addr = (ff*(10*(ff/(bruh/2))))*FRACUNIT
			end
			local ranr = player.mo.radius*2+addr
			local addx = P_ReturnThrustX(nil, rana, ranr)
			local addy = P_ReturnThrustY(nil, rana, ranr)
			local speedang = f*(ANG1*18)
			local axe = FixedMul(-player.speed*5, cos(-ANGLE_90+speedang))
			local speedmom = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
			local ax = P_ReturnThrustX(nil, speedmom, axe)
			local ay = P_ReturnThrustY(nil, speedmom, axe)
			if not player.speed
				ax = 0
				ay = 0
			end
			
			local d = P_SpawnMobjFromMobj(player.mo, addx+ax, addy+ay, addz, MT_DUST)
			local startstate = S_DUST1
			local itab = {
				[0] = 0,
				[1] = 0,
				[2] = 0,
				[3] = 0,
				[4] = 1,
				[5] = 1,
				[6] = 1,
				[7] = 2,
				[8] = 2,
				[9] = 3,
				[10] = 3,
				[11] = 3}
			d.state = startstate+itab[f]
			d.fuse = 2
			d.spriteyoffset = FixedMul(FRACUNIT*5, cos((leveltime%360)*ANG1)) + FixedMul(FRACUNIT*3, cos(f*ANG2))
			if ass < 10
			and f == ass
				P_SetObjectMomZ(d, 5*FRACUNIT)
			end
			if ass < 10
			and f >= ass-2
				if f == ass-2
					d.state = startstate+1
				elseif f == ass-1
					d.state = startstate+2
				elseif f == ass
					d.state = startstate+3
				end
			end
		end
	end
end

local function SpawnPath(player) --Collision stuff
	local prevd
	for i = 1, 3
		local sz = (-350*FRACUNIT)*P_MobjFlip(player.mo)
		if P_MobjFlip(player.mo) == 1
			if player.mo.z+sz < player.mo.floorz
				sz = (player.mo.floorz-5*FRACUNIT)-player.mo.z
			end
		else
			if (player.mo.z+player.mo.height)+sz > player.mo.ceilingz
				sz = (player.mo.ceilingz+5*FRACUNIT)-(player.mo.z+player.mo.height)
			end
		end
		local addz = ((sz/3)*i)*P_MobjFlip(player.mo)
		local speedang = i*(ANG1*18)
		local axe = FixedMul(-player.speed*5, cos(-ANGLE_90+speedang))
		local speedmom = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
		local ax = P_ReturnThrustX(nil, speedmom, axe)
		local ay = P_ReturnThrustY(nil, speedmom, axe)
		if not player.speed
			ax = 0
			ay = 0
		end
		
		local d = P_SpawnMobjFromMobj(player.mo, ax, ay, addz, MT_PARTICLE)
		d.tracer = player.mo
		d.target = player.mo
		d.flags = MF_NOBLOCKMAP|MF_NOCLIPHEIGHT
		d.height = abs(sz/3)
		if i == 3
			d.height = abs(sz/3) - (50*FRACUNIT/3)
		end
		d.radius = player.mo.radius*2
		if i == 3
			d.radius = player.mo.radius*3
		end
		d.state = S_THOK
		d.flags2 = $|MF2_DONTDRAW
		d.tailstornado = true
		d.fuse = 2
		if prevd and prevd.valid
			d.nextd = prevd
		end
		prevd = d
		if i == 1
			d.nextd = player.mo
		end
		/*if P_MobjFlip(d) == 1 --ACZ Dust Devil Dust
			if d.z<d.floorz
				local dustang = P_RandomRange(0, 7)*ANGLE_45
				local dust = P_SpawnMobjFromMobj(d, 96*FixedMul(player.mo.scale, cos(dustang)), 96*FixedMul(player.mo.scale, sin(dustang)), d.floorz-d.z, MT_ARIDDUST)
				dust.state = dust.info.spawnstate + P_RandomRange(0, 2)
				dust.scale = player.mo.scale*3
			end
		else
			if d.z+d.height>d.ceilingz
				local dustang = P_RandomRange(0, 7)*ANGLE_45
				local dust = P_SpawnMobjFromMobj(d, 96*FixedMul(player.mo.scale, cos(dustang)), 96*FixedMul(player.mo.scale, sin(dustang)), d.ceilingz-(d.z+d.height), MT_ARIDDUST)
				dust.state = dust.info.spawnstate + P_RandomRange(0, 2)
				dust.scale = player.mo.scale*3
			end
		end*/
	end
end

local function IsInZ(mobj, mo) --Mobj collide object, Mo - object2
	if mo.z > (mobj.z+mobj.height)
		return
	end
	if (mobj.z-mobj.height) > (mo.z+mo.height)
		return
	end
	return true
end

local function MobjCarry(mo, pd) --Make player carry enemy
	mo.carry = pd
	mo.flags = MF_SCENERY|MF_NOCLIPTHING
	mo.radius = pd.radius/5*4
	if pd.player and pd.player.valid
		pd.player.sustainsucc = 10
		pd.player.carrymo = mo
	end
	if S_SoundPlaying(pd, sfx_s3kcel)
		S_StopSoundByID(pd, sfx_s3kcel)
	end
	S_StartSound(mo, sfx_s3k4a)
	mo.gotosucc = nil
end

local function player_tORmobj_t(mobj)
	if mobj.player and mobj.player.valid
		local player = mobj.player
		if (player.pflags & PF_JUMPED)
		or (player.waiting and player.waiting >= TICRATE*2)
			return 1
		else
			return 0
		end
	else
		return 2
	end
end
rawset(_G,"N_UFAObjects",{})
addHook("MobjMoveCollide", function(mo, mobj) --Ascend the object and make player carry it
	if mo and mo.valid
	and mo.tailstornado
		if mobj and mobj.valid
		and IsInZ(mo, mobj)
		and mobj != mo.target and mobj != mo.tracer
			local porm = player_tORmobj_t(mobj)
			if AcceptThose(mobj)
			or (mobj.player and mobj.player.valid)
				local p = mobj
				if porm == 1 --Player think stuff
					local p2 = mobj.player
					p2.pflags = $|PF_JUMPED|PF_THOKKED|PF_NOJUMPDAMAGE
					p.state = S_PLAY_RIDE
					if mo.nextd and mo.nextd.valid
						local d = mo.nextd
						if d.player and d.player.valid
							if mobj.launchmom
								local mx = mobj.launchmom.x
								local my = mobj.launchmom.y
								local mz = mobj.launchmom.z
								local sprx = P_AproxDistance(P_AproxDistance(mx,my),mz)
								P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, sprx, false)
							else
								P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, FRACUNIT, true)
							end
							local px = d.x
							local py = d.y
							local pz = d.z+d.height/2
							local fx = p.x+p.momx
							local fy = p.y+p.momy
							local fz = (p.z+p.height/2)+p.momz
							local aprx = P_AproxDistance(P_AproxDistance(px-fx,py-fy),pz-fz)
							if aprx <= 50*FRACUNIT
								P_ResetPlayer(p2)
								p.tracer = d
								p2.powers[pw_carry] = CR_PLAYER
								P_TryMove(p, d.x, d.y)
								S_StartSound(p, sfx_s3k4a)
								d.player.sustainsucc = 10
								d.player.dodasuck = false
								if S_SoundPlaying(d, sfx_s3kcel)
									S_StopSoundByID(d, sfx_s3kcel)
								end
							end
						else
							P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, FRACUNIT, true)
							mobj.launchmom = {
							x = mobj.momx,
							y = mobj.momy,
							z = mobj.momz}
						end
					end
				elseif porm == 2 --Enemy think stuff
					mobj.wascarried = true
					mobj.tracer = mo.tracer
					if mo.nextd and mo.nextd.valid
						local d = mo.nextd
						p.gotosucc = mo.tracer
						p.nosucc = 15
						p.thrown = false
						if d.player and d.player.valid
							if mobj.launchmom
								local mx = mobj.launchmom.x
								local my = mobj.launchmom.y
								local mz = mobj.launchmom.z
								local sprx = P_AproxDistance(P_AproxDistance(mx,my),mz)
								P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, sprx, false)
							else
								P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, FRACUNIT, true)
							end
							local px = d.x
							local py = d.y
							local pz = d.z+d.height/2
							local fx = p.x+p.momx
							local fy = p.y+p.momy
							local fz = (p.z+p.height/2)+p.momz
							local aprx = P_AproxDistance(P_AproxDistance(px-fx,py-fy),pz-fz)
							if aprx <= 50*FRACUNIT
								p.nosucc = 0
								p.removegotosucc = false
								if TN_EnemyCarry[mobj.type] and TN_EnemyCarry[mobj.type].type and TN_EnemyCarry[mobj.type].type == "spring"
									P_SetObjectMomZ(mobj, -mobj.info.mass)
									P_DoSpring(mobj, d)
									mobj.gotosucc = nil
									mobj.walkpath = 0
								elseif TN_EnemyCarry[mobj.type] and TN_EnemyCarry[mobj.type].type and TN_EnemyCarry[mobj.type].type == "damage"
									local dmg = TN_EnemyCarry[mobj.type].var
									if dmg < 0
										if P_RandomChance(abs(dmg))
											P_DamageMobj(d, mobj, mobj, 1)
										else
											MobjCarry(mobj, d)
										end
									else
										local premom = {
										x = d.momx,
										y = d.momy,
										z = d.momz}
										if dmg > 0
											P_DamageMobj(d, mobj, mobj, 1)
										else
											P_DamageMobj(d, mobj, mobj, 1, 7)
										end
									end
									mobj.gotosucc = nil
									mobj.walkpath = 0
								else
									MobjCarry(mobj, d)
								end
							end
						else
							P_FlyTo(mobj, d.x, d.y, d.z+d.height/2, FRACUNIT, true)
							mobj.launchmom = {
							x = mobj.momx,
							y = mobj.momy,
							z = mobj.momz}
						end
					end
				end
				if not mobj.nosucky
					AddToTable(mobj,N_UFAObjects)
				end
				mobj.noufaobjects = TICRATE
				mobj.nosucky = 3
			end
		end
	end
end, MT_PARTICLE)

addHook("PlayerThink", function(player) --Stuff for all of this shit
	if not player.spectator
	and player.mo
		if player.mo.skin == "recenttails"
			player.tailsnewreal = true
		else
			if player.tailsnewreal
				if player.carrymo and player.carrymo.valid
					player.carrymo.carry = nil
					player.carrymo.radius = mobjinfo[player.carrymo.type].radius
					player.carrymo.uncarry = 15
					if (player.carrymo.info.flags & MF_MISSILE)
						player.carrymo.target = player.mo
					end
					player.carrymo.thrown = true
					player.carrymo.thrownby = player.mo
					player.carrymo = nil
					player.dodasuck = false
				end
				player.nosuccpls = 15
				player.sustainsucc = 0
				player.startsucc = 0
				player.dodasuck = false
				player.nodrop = 0
				player.droprangs = false
			end
			player.tailsnewreal = false
		end
	end
	if not N_ReturnPlayer(player) return end
		if player.powers[pw_carry] == CR_PLAYER
			if player.mo.tracer and player.mo.tracer.valid
				local p = player.mo.tracer
				if p.player and p.player.valid
				and p.skin == "recenttails"
					p.player.pcarry = player
					p.player.removepcarry = 5
					if p.player.dotheflip
						player.grabbuddy = p.player
					end
				end
			end
		end
		player.waiting = $ or 0
		if player.mo.state == S_PLAY_WAIT
			player.waiting = $+1
		else
			player.waiting = 0
		end
	if player.mo.skin == "recenttails"
		player.removepcarry = $ or 0
		if player.removepcarry
			player.removepcarry = $ - 1
			player.nomorepcarry = true
		elseif player.nomorepcarry
			player.pcarry = nil
			player.nomorepcarry = false
		end
	
		player.startsucc = $ or 0
		player.nosuccpls = $ or 0
		player.removemo = $ or 0
		if player.removemo then player.removemo = $-1 player.dotheremoval = true else if player.dotheremoval then player.carrymo = nil end player.dotheremoval = false end
		if player.nosuccpls then player.nosuccpls = $-1 end
		if not player.enemyinv
			player.enemyinv = {}
		end
		if player.pcarry and player.pcarry.valid
			player.nosuccpls = 5
		end
		if player.startsucc and player.startsucc > 10 then player.startsucc = 10 end
		if player.powers[pw_tailsfly]
			if player.extrabutton
			and player.cmd.buttons & player.extrabutton
				if not player.nosuccpls
					if not player.succ
						player.mo.momx = $/2
						player.mo.momy = $/2
						player.mo.momz = $/2
						player.dodasuck = true
						if S_SoundPlaying(player.mo, sfx_s3kcel)
							S_StopSoundByID(player.mo, sfx_s3kcel)
						end
					elseif player.dodasuck
						if not S_SoundPlaying(player.mo, sfx_s3kcel)
							S_StartSound(player.mo, sfx_s3kcel)
						end
						player.stopsound = true
						SpawnPath(player)
						if (leveltime%2) == 0
							player.powers[pw_tailsfly] = $+1
						end
						player.mo.momz = $/2
						player.startsucc = $ + 1
						if player.startsucc
							SpawnVortex(player, player.startsucc)
						end
					end
				else
					if player.pcarry and player.pcarry.valid
						local p = player.pcarry
						local pp = player.pcarry.mo
					end
					if player.carrymo and player.carrymo.valid
						if not player.succ
							S_StartSound(player.mo, sfx_ngjump)
							player.carrymo.carry = nil
							if (player.carrymo.info.flags & MF_MISSILE)
								player.carrymo.target = player.mo
							end
							player.carrymo.radius = mobjinfo[player.carrymo.type].radius
							player.carrymo.uncarry = 15
							player.carrymo.thrown = true
							player.carrymo.thrownby = player.mo
							player.carrymo = nil
							player.dodasuck = false
							player.nosuccpls = 15
							player.startsucc = 0
							player.sustainsucc = 0
						end
					end
				end
			else
				if S_SoundPlaying(player.mo, sfx_s3kcel)
				and player.stopsound
					S_StopSoundByID(player.mo, sfx_s3kcel)
					player.stopsound = false
				end
				if not player.nosuccpls
					if player.startsucc
						player.startsucc = $ - 1
						SpawnVortex(player, player.startsucc)
					end
					player.dodasuck = false
				end
			end
		end
		if player.carrymo and player.carrymo.valid
			if player.carrymo.type == MT_WINDBALL
				player.carrymo.starttimer = false
				player.carrymo.expt = player.carrymo.info.reactiontime
			end
			if S_SoundPlaying(player.mo, sfx_s3kcel)
				S_StopSoundByID(player.mo, sfx_s3kcel)
			end
			player.pflags = $&~PF_CANCARRY
			local mo = player.carrymo
			mo.accelheg = $ or 0
			mo.heg2 = $ or 0
			if not mo.uncarry
				local c = player.mo
				mo.flags = MF_SCENERY|MF_NOCLIPTHING
				mo.radius = c.radius/5*4
				local heg = -mo.height-5*FRACUNIT
				mo.heg2 = $ or 0
				local heg3 = -mo.height-5*FRACUNIT
				if P_MobjFlip(c) == -1
					heg3 = c.height+5*FRACUNIT+mo.height
				else
					heg3 = -mo.height-5*FRACUNIT
				end
				local check = P_SpawnMobjFromMobj(c, 0, 0, 0, MT_THOK)
				P_TeleportMove(check, 
					c.x+P_ReturnThrustX(nil, player.drawangle, FRACUNIT),
					c.y+P_ReturnThrustY(nil, player.drawangle, FRACUNIT),
					c.z+heg3)
				check.flags2 = $|MF2_DONTDRAW
				check.height = mo.height
				check.radius = mo.radius
				check.fuse = 2
				if (c.state != S_PLAY_FLY
				and c.state != S_PLAY_FLY_TIRED
				and c.state != S_PLAY_SWIM
				and c.state != S_PLAY_RIDE)
				or (P_IsObjectOnGround(check))
					if P_MobjFlip(c) == 1
						heg = c.height+5*FRACUNIT
					else
						heg = -5*FRACUNIT-mo.height
					end
					if mo.type == MT_FANG
						mo.state = S_FANG_BOUNCE2
						mo.frame = 14
					end
				else
					if P_MobjFlip(c) == -1
						heg = 5*FRACUNIT+mo.height
					else
						heg = -mo.height-5*FRACUNIT
					end
					if mo.type == MT_FANG
						mo.state = S_FANG_BOUNCE2
						mo.skin = "fang"
						mo.color = SKINCOLOR_LAVENDER
						mo.sprite = SPR_PLAY
						mo.sprite2 = SPR2_RIDE
						mo.frame = A
					end
				end
				if heg > mo.heg2
					mo.accelheg = $+FRACUNIT
					if (mo.heg2+mo.accelheg) < heg
						mo.heg2 = $+mo.accelheg
					else
						mo.heg2 = heg
						mo.accelheg = 0
					end
				end
				if heg < mo.heg2
					mo.accelheg = $+FRACUNIT
					if (mo.heg2-mo.accelheg) > heg
						mo.heg2 = $-mo.accelheg
					else
						mo.heg2 = heg
						mo.accelheg = 0
					end
				end
				if P_MobjFlip(c) == -1
					mo.flags2 = $|MF2_OBJECTFLIP
					mo.eflags = $|MFE_VERTICALFLIP
				else
					mo.flags2 = $&~MF2_OBJECTFLIP
					mo.eflags = $&~MFE_VERTICALFLIP
				end
				mo.movedir = -1
				if mo.type != MT_GFZFISH
					mo.angle = player.drawangle
				end
				mo.target = nil
				if (mo.flags & MF_MISSILE)
					mo.target = c
				end
				local ax = P_ReturnThrustX(nil, player.drawangle, FRACUNIT)
				local ay = P_ReturnThrustY(nil, player.drawangle, FRACUNIT)
				P_TeleportMove(mo, c.x+ax, c.y+ay, c.z+mo.heg2)
				if ((TN_EnemyCarry[mo.type]
				and TN_EnemyCarry[mo.type].type
				and TN_EnemyCarry[mo.type].type != "turret")
				or (not TN_EnemyCarry[mo.type]))
				or mo.info.mass == 100
					mo.momx = c.momx
					mo.momy = c.momy
				end
				mo.momz = c.momz
				player.carrymo = mo
				player.removemo = 5
				player.nosuccpls = 15
			end
			if (player.carrymo.health <= 0 or player.carrymo.state == player.carrymo.info.deathstate)
				if player.powers[pw_tailsfly]
					player.pflags = $|PF_CANCARRY
				end
				player.carrymo.carry = nil
				if (player.carrymo.info.flags & MF_MISSILE)
					player.carrymo.target = player.mo
				end
				if player.carrymo.type == MT_FANG
					player.carrymo.state = S_FANG_BOUNCE2
					player.carrymo.tics = 10
					player.carrymo.frame = 12
					player.carrymo.flags2 = $&~MF2_DONTDRAW
				end
				player.carrymo.radius = player.carrymo.info.radius
				player.carrymo.uncarry = 15
				player.carrymo.thrown = true
				player.carrymo.thrownby = player.mo
				player.carrymo = nil
				player.dodasuck = false
				player.nosuccpls = 15
				player.startsucc = 0
				player.sustainsucc = 0
			end
		else
			if player.powers[pw_tailsfly]
				player.pflags = $|PF_CANCARRY
			end
		end
		player.sustainsucc = $ or 0
		if player.sustainsucc then player.sustainsucc = $-1 end
		if player.succ
		and not player.powers[pw_tailsfly]
		and not player.nosuccpls
			player.sustainsucc = 10
		end
		if player.sustainsucc
		and player.startsucc
			player.startsucc = $ - 1
			SpawnVortex(player, player.startsucc)
		end
		if P_IsObjectOnGround(player.mo)
			player.startsucc = 0
		end
		if player.extrabutton
		and player.cmd.buttons & player.extrabutton
			player.succ = true
		else
			player.succ = false
		end
	end
end)

local function GetDrawang(mo)
	if mo.player and mo.player.valid
		return mo.player.drawangle
	end
	return mo.angle
end
local function ReturnMobj(mo)
	if mo and mo.valid
	and mo.wascarried
		return true
	end
	return false
end

addHook("ThinkFrame", function() --Just so stuff works properly.
	for i,k in pairs(N_UFAObjects)
		local mo = N_UFAObjects[i]
		if not mo.valid
		or mo.health <= 0
            table.remove(N_UFAObjects, i)
            continue
        end
		mo.nosucky = $ or 0
		if mo.nosucky mo.nosucky = $-1 mo.noufaobjects = TICRATE end
		if mo.thrown
		and not P_IsObjectOnGround(mo)
			mo.removecarryopti = 0
			mo.wascarried = true
			mo.noufaobjects = 5
		end
		if TN_EnemyCarry[mo.type]
			local var = TN_EnemyCarry[mo.type].var
			TN_HeavyCarry(mo, var)
			TN_SpeedCarry(mo, var)
			TN_TurretCarry(mo, var)
			TN_BomberCarry(mo, var)
		end
		mo.uncarry = $ or 0
		if mo.uncarry
			mo.uncarry = $ - 1
			mo.noufaobjects = TICRATE
			mo.golksdnfl = true
		elseif mo.golksdnfl
			mo.flags = mo.info.flags
			if mo.type == MT_FANG
				mo.flags = $&~MF_NOCLIPTHING
			end
			if mo.flags & MF_MONITOR and (mo.health <= 0 or mo.state == mo.info.deathstate)
				mo.flags = $&~(MF_MONITOR|MF_SHOOTABLE)
			end
			mo.golksdnfl = false
		end
		if mo.carry and mo.carry.valid
		and mo.carry.player and mo.carry.player.valid
		and mo.carry.player.carrymo != mo
			mo.radius = mobjinfo[mo.type].radius
			mo.uncarry = 15
			mo.thrown = true
			if (mo.flags & MF_MISSILE)
				mo.target = mo.carry
			end
			mo.noufaobjects = TICRATE
			mo.thrownby = mo.carry
			mo.carry = nil
		end
		mo.nosucc = $ or 0
		if mo.nosucc
			mo.nosucc = $-1
			mo.noufaobjects = TICRATE
			mo.removegotosucc = true
		elseif mo.removegotosucc
			mo.flags = mo.info.flags
			if mo.type == MT_FANG
				mo.flags = $&~MF_NOCLIPTHING
			end
			if (mo.info.flags & MF_MONITOR)
			and not (mo.flags & MF_MONITOR)
				mo.flags = $|MF_MONITOR|MF_SHOOTABLE
			end
			mo.gotosucc = nil
			mo.removegotosucc = false
		end
		if mo.gotosucc and mo.gotosucc.valid
			local pd = mo.gotosucc
			mo.walkpath = $ or 0
			if (mo.info.flags & MF_MONITOR
			and mo.flags & MF_MONITOR)
				mo.flags = $&~(MF_MONITOR|MF_SHOOTABLE)
			end
		end
		mo.removecarryopti = $ or 0
		if not mo.uncarry
		and not mo.thrown
		and not mo.carry
		and (P_IsObjectOnGround(mo) and not (mo.flags & MF_NOGRAVITY))
			mo.removecarryopti = $+1
			if mo.removecarryopti >= 3*TICRATE
				mo.removecarryopti = 0
				mo.wascarried = false
				mo.flags = mo.info.flags
				if mo.type == MT_FANG
					mo.flags = $&~MF_NOCLIPTHING
				end
				if (mo.info.flags & MF_MONITOR)
				and not (mo.flags & MF_MONITOR)
					mo.flags = $|MF_MONITOR|MF_SHOOTABLE
				end
				mo.gotosucc = nil
				mo.removegotosucc = false
			end
			mo.noufaobjects = TICRATE
		end
		if mo.thrown
		and not P_IsObjectOnGround(mo)
			mo.removecarryopti = 0
			mo.wascarried = true
			mo.noufaobjects = TICRATE
		end
	end
end)

addHook("MobjDamage", function(mo, mobj, src, dmg, dmgtype)
	if mo and mo.valid
		if mo.player and mo.player.valid
			if mobj and mobj.valid
				if mobj.gotosucc and mobj.gotosucc.valid
				and mobj.gotosucc == mo
					return true
				end
				if mobj.carry and mobj.carry.valid
				and mobj.carry == mo
					return true
				end
			end
			if dmgtype == 7
				local player = mo.player
				P_ResetPlayer(player)
				player.powers[pw_flashing] = flashingtics-1
				P_PlayerRingBurst(player)
				P_PlayRinglossSound(mo)
				player.rings = 0
				player.mo.state = S_PLAY_FALL
				player.powers[pw_tailsfly] = 0
				P_ResetPlayer(player)
				player.powers[pw_flashing] = flashingtics-1
				player.mo.state = S_PLAY_FALL
				player.pflags = $&~(PF_STASIS|PF_JUMPSTASIS)
				return true
			end
		else
			if mobj and mobj.valid
			and mobj.player and mobj.player.valid
				if mobj.player.carrymo and mobj.player.carrymo.valid
				and mobj.player.carrymo == mobj
					return true
				end
			end
		end
	end
end)