freeslot("sfx_taunt","SPR_TANT","SPR2_TANT","S_PLAY_TAUNT")
for i = 1, 4
	freeslot("S_TAUNT"..i)
end
states[S_TAUNT1] = {SPR_TANT,A|FF_FULLBRIGHT,2,nil,1,0,S_TAUNT2}
states[S_TAUNT2] = {SPR_TANT,B|FF_FULLBRIGHT,3,nil,1,0,S_TAUNT3}
states[S_TAUNT3] = {SPR_TANT,C|FF_FULLBRIGHT,2,nil,1,0,S_TAUNT4}
states[S_TAUNT4] = {SPR_TANT,D|FF_FULLBRIGHT,13,nil,1,0,S_NULL}

states[S_PLAY_TAUNT] = {SPR_PLAY,SPR2_TANT,20,nil,0,0,S_PLAY_STND}

addHook("PlayerThink", function(player)
	if player.valid and player.playerstate == PST_LIVE and not player.spectator
	and player.powers[pw_carry] != CR_NIGHTSMODE and player.mo
		player.tauntcd = $ or 0
		if player.tauntcd player.tauntcd = $-1 end
		
		local function CanTaunt(player)
			local s = player.powers[pw_shield]
		
			if player.teamnew
				return false
			end
			if (player.pflags & PF_JUMPED)
				if s
					if not (s&SH_FIREFLOWER)
						return false
					end
				end
			end
			if All7Emeralds(emeralds)
			and player.rings >= 50
				return false
			end
			return false --Return true to be able to taunt! No actual sprites yet so uh, no. 
		end
	
		if player.shieldbutton and player.cmd.buttons & player.shieldbutton
			if not player.taunt
			and not player.tauntcd
			and CanTaunt(player)
			and P_IsValidSprite2(player.mo, SPR2_TANT)
			and CanUse(player)
			and not player.bashstate
				player.bashhome = 0
				player.prevstate = player.mo.state
				player.prevmom = {x = player.mo.momx,y = player.mo.momy,z = player.mo.momz}
				player.tauntcd = 25
				player.mo.state = S_PLAY_TAUNT
				player.mo.frame = P_RandomRange(A,B)
				if player.followmobj and player.followmobj.valid
					player.followmobj.flags2 = $|MF2_DONTDRAW
				end
				local b = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_OVERLAY)
				b.state = S_TAUNT1
				b.target = player.mo
				S_StartSound(player.mo, sfx_taunt)
			end
			player.taunt = true
		else
			player.taunt = false
		end
		
		if player.mo.state == S_PLAY_TAUNT
			player.mo.momx = 0
			player.mo.momy = 0
			player.mo.momz = 0
			player.pflags = $|PF_FULLSTASIS
			player.ta = true
		else
			if player.ta
				if player.prevstate
					player.mo.state = player.prevstate
				end
				if player.prevmom
					player.mo.momx = player.prevmom.x
					player.mo.momy = player.prevmom.y
					player.mo.momz = player.prevmom.z
				end
				if player.followmobj and player.followmobj.valid
					player.followmobj.flags2 = $&~MF2_DONTDRAW
				end
			end
			player.ta = false
		end
	end
end)