--If you are thinkin of making a Team Mod, then please. Make your own code, in that hour i suffered so much from this.

addHook("MapLoad", function()
	local p1
	local p2
	local p3
	if players[0] and players[0].valid
		p1 = players[0]
	end
	if players[1] and players[1].valid
		p2 = players[1]
	end
	if players[2] and players[2].valid
		p3 = players[2]
	end
	if p1 and p1.valid
	and p2 and p2.valid
	and TeamNew(p1.mo.skin) and p2.mo.skin != p1.mo.skin and TeamNew(p2.mo.skin)
	and not splitscreen
	and not multiplayer
	and not netgame
		R_SetPlayerSkin(p1, "sonicnew")
		p1.mo.color = SKINCOLOR_BLUE
		
		R_SetPlayerSkin(p2, "recenttails")
		p2.mo.color = SKINCOLOR_ORANGE
		
		if not p3
			local bot = G_AddPlayer("leknux", SKINCOLOR_RED, "Latest Edition Knux", BOT_2PAI)
			bot.botleader = p1
			bot.third = true
		elseif p3 and p3.valid
			R_SetPlayerSkin(p3, "leknux")
			p3.mo.color = SKINCOLOR_RED
			p3.notricks = true
		end
		
		p1.switch = 0
		p1.teamnew = true
		p1.nexts = p2.mo.skin
		p1.nextc = p2.mo.color
	elseif p1 and p1.valid
		p1.teamnew = false
		p1.switch = 0
	end
end)

local function SwitchOut(t, s)
	if players[t] and players[t].valid
		local player = players[t]
		local px = player.mo.x
		local py = player.mo.y
		local pz = player.mo.z
				
		local mx = player.mo.momx
		local my = player.mo.momy
		local mz = player.mo.momz
		if players[s] and players[s].valid
		and players[s].playerstate == PST_LIVE
		and players[s] != players[t]
			local p = players[s]
			
			for i = 1, 2
				local vs = players[s]
				local vg = players[t]
				if i == 1 vs = players[s] vg = players[t] else vs = players[t] vg = players[s] end
				local vm = vs.mo
				local vh = vg.mo
			
				local v = P_SpawnMobjFromMobj(vm,0,0,vm.height/2, MT_THOK)
				v.scale = vm.scale
				v.destscale = vh.scale
				v.tics = -1
				v.color = vm.color
				v.target = vh
				v.switchteam = true
				AddToTable(v, N_GlobalThinkers)
			end
			
			local prevskin = player.mo.skin
			local prevcolor = player.mo.color
			player.mo.color = p.mo.color
			R_SetPlayerSkin(player, p.mo.skin)
			
			local prevsh = player.powers[pw_shield]
			player.powers[pw_carry] = p.powers[pw_carry]
			P_SpawnShieldOrb(player)
			
			player.mo.spritexscale = FRACUNIT
			player.mo.spriteyscale = FRACUNIT
			player.acceldash = 0
			player.stopaccel = 0
			player.doaccel = false
			if player.usespring --If used spring as sonic, then thokked
				player.pflags = $|PF_THOKKED
			elseif (player.pflags & PF_THOKKED) --If hasnt used spring, then can use ability.
				player.pflags = $&~PF_THOKKED
			end
			
			R_SetPlayerSkin(p, prevskin)
			p.mo.color = prevcolor
			p.powers[pw_carry] = prevsh
			P_SpawnShieldOrb(p)
			
			player.notricks = true
			p.notricks = true
		end
	end
end

local function ReturnTeam()
	local sonic
	local tails
	local knux
			
	for i = 0,2
		if players[i] and players[i].valid
			local p = players[i]
			if TeamNew(p.mo.skin) == 1
				sonic = i
			end
			if TeamNew(p.mo.skin) == 2
				tails = i
			end
			if TeamNew(p.mo.skin) == 3
				knux = i
			end
		end
	end
	local fromstot = {
	[0] = tails,
	[1] = knux,
	[2] = sonic}
	return fromstot
end

addHook("PlayerSpawn", function(player)
	if player.valid
	and not splitscreen
	and not multiplayer
	and not netgame
		player.switch = 0
		player.teamnew = true
		if players[1] and players[1].valid
		and players[1].mo and players[1].mo.valid
			player.nexts = players[1].mo.skin
			player.nextc = players[1].mo.color
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.valid and not player.spectator
	and player.mo
	and player.teamnew
	and player.mo.skin
	and TeamNew(player.mo.skin)
	and not splitscreen
	and not multiplayer
	and not netgame
		if player.usespring
		and (P_IsObjectOnGround(player.mo)
		or player.powers[pw_carry])
			player.usespring = false
			player.notricks = false
		end
		player.switch = $ or 0
		local function CanSwitch(player)
			if P_PlayerInPain(player)
			or player.stunpainrings
			or player.playerstate != PST_LIVE --Can only switch when alive!
				return false
			end
			if player.bashstate
				return false
			end
			local s = (player.powers[pw_shield])&~SH_FIREFLOWER
			if player.pflags & PF_JUMPED
			and s
				return false
			end
			if TeamNew(player.mo.skin) == 1
				if All7Emeralds(emeralds)
				and player.rings >= 50
					return false
				end
				return true
			end
			return true
		end
		local toskin = {[0] = 1,[1] = 2,[2] = 0}
		if player.shieldbutton and player.cmd.buttons & player.shieldbutton
			if not player.burh
			and CanSwitch(player)
				player.justswitched = true
			end
			player.burh = true
		else
			player.burh = false
		end
		
		if player.justswitched
			local n1 = 0
			local n2 = 1
			
			local fromstot = ReturnTeam()
			if fromstot[TeamNew(player.mo.skin)-1]
				n2 = fromstot[TeamNew(player.mo.skin)-1]
				SwitchOut(n1,n2)
				
				fromstot = ReturnTeam()
				if fromstot[TeamNew(player.mo.skin)-1]
					player.n3 = fromstot[TeamNew(player.mo.skin)-1]
				end
			end
			
			player.justswitched = false
		end
		if player.n3
		and players[player.n3] and players[player.n3].valid
			player.nexts = players[player.n3].mo.skin
			player.nextc = players[player.n3].mo.color
		end
	end
end)

addHook("HUD", function(v,player,cam)
	if player and player.valid
	and not splitscreen
	and not multiplayer
	and not netgame
		if player.teamnew and player.nexts and player.nextc
			local s = v.cachePatch("SWITCHLIFE")
			local l = hudinfo[HUD_LIVES]
			local n = v.getSprite2Patch(player.nexts,"XTRA",false,A,0,0)
			local f = l.f
			if hud.enabled("lives")
				v.drawScaled(l.x*FRACUNIT,(l.y*FRACUNIT)-(16*FRACUNIT),FRACUNIT/2,s,f|V_HUDTRANSHALF)
				v.drawScaled((l.x*FRACUNIT)+(16*FRACUNIT),(l.y*FRACUNIT)-(16*FRACUNIT),FRACUNIT/2,n,f|V_HUDTRANSHALF,v.getColormap(player.nexts, player.nextc))
			else
				local you = v.getSprite2Patch(player.mo.skin,"XTRA",false,A,0,0)
				v.drawScaled(l.x*FRACUNIT,l.y*FRACUNIT,FRACUNIT/2,you,f|V_HUDTRANS,v.getColormap(player.mo.skin, player.mo.color))
				
				v.drawScaled((l.x*FRACUNIT)+(16*FRACUNIT),l.y*FRACUNIT,FRACUNIT/2,s,f|V_HUDTRANS)
				v.drawScaled((l.x*FRACUNIT)+(32*FRACUNIT),l.y*FRACUNIT,FRACUNIT/2,n,f|V_HUDTRANS,v.getColormap(player.nexts, player.nextc))
			end
		end
	end
end,"game")