addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.diganim = $ or 0
		if player.diganim
			player.diganim = $ - 1
			player.nocrouch = 2
			player.deggin = true
			if player.mo.state != S_PLAY_EDGE
				player.mo.state = S_PLAY_EDGE
			end
			player.powers[pw_flashing] = 1
			if player.gotodig
				P_TryMove(player.mo, player.gotodig.x, player.gotodig.y)
			end
			if not S_SoundPlaying(player.mo, sfx_mindig)
				S_StartSound(player.mo, sfx_mindig)
			end
			player.pflags = $|PF_FULLSTASIS
			if (leveltime&10) <= 4
				player.mo.mirrored = true
			else
				player.mo.mirrored = false
			end
			player.mo.spriteyoffset = $ - (FRACUNIT/3*4)*2
		else
			if player.deggin
			and player.gotodig
				player.notricks = true
				player.mo.mirrored = false
				player.mo.spriteyoffset = 0
				player.mo.state = S_PLAY_GLIDE_LANDING
				player.mo.tics = 10
				player.nocrouch = 10
				player.dotheflip = false
				P_TeleportMove(player.mo, player.gotodig.x, player.gotodig.y, player.gotodig.z)
				for i = 1, 6
					local ranang = ((360/6)*i)*ANG1 + P_RandomRange(-5, 5)*ANG1
					local ranx = P_ReturnThrustX(nil, ranang, player.mo.radius/3)
					local rany = P_ReturnThrustY(nil, ranang, player.mo.radius/3)
							
					local digdig = P_SpawnMobj(player.gotodig.x+ranx, player.gotodig.y+rany, player.gotodig.z, MT_MINUSDIRT)
					if not player.gotodig.flip
						digdig.flags2 = $|MF2_OBJECTFLIP
						digdig.eflags = $|MFE_VERTICALFLIP
					end
				end
				local digsurf = P_SpawnMobj(player.gotodig.x, player.gotodig.y, player.gotodig.z, MT_MINUSDIRT)
				if player.gotodig.extra1
					digsurf.state = S_MINUSDIRT2
					digsurf.tics = TICRATE*10
					digsurf.flags = MF_SCENERY|MF_SPECIAL
					digsurf.digdown = {}
					digsurf.digdown.x = player.gotodig.x
					digsurf.digdown.y = player.gotodig.y
					digsurf.digdown.z = player.gotodig.dig
					player.powers[pw_gravityboots] = 0
					player.dotheflip = false
					player.dontunflip = 0
				else
					player.powers[pw_gravityboots] = 5
					player.dotheflip = true
					player.dontunflip = 15
					player.unfliptrue = 2
				end
				if not player.gotodig.flip
					digsurf.flags2 = $|MF2_OBJECTFLIP
					digsurf.eflags = $|MFE_VERTICALFLIP
				end
				S_StartSound(player.mo, sfx_crumbl)
			end
			player.deggin = false
		end
	end
end)