addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "leknux"
		player.throwrock = $ or 0
		player.holdingrock = $ or 0
		player.growrock = $ or 0
		if player.holdingrock
			player.holdingrock = $ - 1
			if player.holdrock and player.holdrock.valid --Hold rock
				player.washolding = true
				if player.diganim
					player.holdrock.spriteyoffset = $-FRACUNIT/3*4
				else
					player.holdrock.spriteyoffset = 0
				end
				local flipheg = player.mo.z+player.mo.height+15*FRACUNIT
				if P_MobjFlip(player.mo) == 1
					flipheg = player.mo.z+player.mo.height+15*FRACUNIT
					player.holdrock.flags2 = $&~MF2_OBJECTFLIP
					player.holdrock.eflags = $&~MFE_VERTICALFLIP
				else
					flipheg = player.mo.z-30*FRACUNIT
					player.holdrock.flags2 = $|MF2_OBJECTFLIP
					player.holdrock.eflags = $|MFE_VERTICALFLIP
				end
				P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, flipheg)
				player.holdrock.momx = player.mo.momx
				player.holdrock.momy = player.mo.momy
				player.holdrock.momz = player.mo.momz
				if player.ghbag
					if player.growrock < player.ghbag*FRACUNIT
						player.growrock = $+FRACUNIT/5
					end
					local multi = player.growrock
					if multi <= 0
						multi = 1
					else
						multi = player.growrock/10
					end
					player.holdrock.scale = FRACUNIT+multi
				else
					player.holdrock.scale = FRACUNIT
					player.holdrock.fuse = TICRATE*5
					player.holdrock.destscale = FRACUNIT/3
					player.holdrock.scalespeed = FRACUNIT/TICRATE/5
				end
				player.holdrock.fuse = TICRATE*5
				if player.crouching
				or player.glidetime
				or player.climbing
				or player.dotheflip
				or player.diganim
					player.holdingrock = 15
				end
				
				local ptarg = P_LookForEnemies(player, false, true) --Lock-on
				if ptarg and ptarg.valid
					P_SpawnLockOn(player, ptarg, S_LOCKON1)
				end
				if not player.nogroundjump --Throw rock
				and (player.cmd.buttons & BT_SPIN)
				and not player.nogroundjump
					player.holdingrock = 0
					if player.dotheflip
						if P_MobjFlip(player.mo) == 1
							player.holdrock.flags2 = $|MF2_OBJECTFLIP
							player.holdrock.eflags = $|MFE_VERTICALFLIP
						else
							player.holdrock.flags2 = $&~MF2_OBJECTFLIP
							player.holdrock.eflags = $&~MFE_VERTICALFLIP
						end
					end
					P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2)
					player.holdrock.flags = $&~MF_SPECIAL
					player.holdrock.state = player.holdrock.info.spawnstate
					player.holdrock.scale = FRACUNIT
					player.holdrock.fuse = TICRATE*5
					player.holdrock.destscale = FRACUNIT/3
					player.holdrock.scalespeed = FRACUNIT/TICRATE/5
					if player.growrock
						local multi = player.growrock
						if multi <= 0
							multi = 1
						else
							multi = player.growrock/10
						end
						player.holdrock.scale = FRACUNIT+multi
						player.holdrock.fuse = TICRATE*5 + ((multi/FRACUNIT)*5)
						player.holdrock.destscale = FRACUNIT/3
						player.holdrock.scalespeed = FRACUNIT/(TICRATE*5 + ((multi/FRACUNIT)*5))
						if player.ghbag
							player.ghbag = $-(player.growrock/FRACUNIT) 
						end
						if multi >= FRACUNIT/4*3
						and multi < (FRACUNIT/4*3)*2
							player.holdrock.damageadd = 1
						elseif multi >= (FRACUNIT/4*3)*2
							player.holdrock.damageadd = 2
						end
					end
					local targ = P_LookForEnemies(player, false, true)
					if targ and targ.valid
						P_ParabolicMove(player.holdrock, targ.x, targ.y, targ.z, 20*FRACUNIT)
					else
						P_InstaThrust(player.holdrock, player.mo.angle, 20*FRACUNIT)
						P_SetObjectMomZ(player.holdrock, 5*FRACUNIT)
					end
					player.nocrouch = 15
					P_Thrust(player.mo, R_PointToAngle2(0, 0, player.holdrock.momx, player.holdrock.momy)+ANGLE_180, 5*FRACUNIT)
					if not player.dotheflip
						P_SetObjectMomZ(player.mo, 5*FRACUNIT, true)
					end
					S_StartSound(player.mo, sfx_wbreak)
					player.throwrock = TICRATE
					player.pleaseplayanim = true
					player.growrock = 0
				end
			end
		else
			if player.washolding
			and player.holdrock and player.holdrock.valid
				if player.dotheflip
					if P_MobjFlip(player.mo) == 1
						player.holdrock.flags2 = $|MF2_OBJECTFLIP
						player.holdrock.eflags = $|MFE_VERTICALFLIP
					else
						player.holdrock.flags2 = $&~MF2_OBJECTFLIP
						player.holdrock.eflags = $&~MFE_VERTICALFLIP
					end
				end
				P_TeleportMove(player.holdrock, player.mo.x, player.mo.y, player.mo.z+player.mo.height/2)
			end
			player.washolding = false
			player.growrock = 0
		end
		if player.throwrock
			player.throwrock = $ - 1
			if player.pleaseplayanim
				player.mo.state = S_PLAY_EDGE
				player.mo.frame = A
				player.mo.tics = -1
				if player.crouching
				and not player.nocrouch
					player.throwrock = 0
					player.pleaseplayanim = true
				end
			end
		else
			if player.pleaseplayanim
				if P_IsObjectOnGround(player.mo)
					player.mo.state = S_PLAY_WALK
				else
					player.mo.state = S_PLAY_FALL
				end
			end
			player.pleaseplayanim = false
		end
	end
end)