addHook("PlayerThink", function(player)
	if not N_ReturnPlayer(player) return end
	if player.mo.skin == "sonicnew"
		player.supertimer = $ or 0
		if player.powers[pw_super] --Main super form stuff
			SNEW_Cyaura(player, player.mo.color)
			if (player.mo.state == S_PLAY_STND
			or player.mo.state == S_PLAY_FLOAT)
			and not player.secondjump
				player.supertimer = $+1
				if player.supertimer >= TICRATE*2
				and not player.superwait
					player.mo.state = S_PLAY_FLOAT
					P_SetObjectMomZ(player.mo, 5*FRACUNIT)
					player.superwait = true
					player.supertimer = 0
				end
			end
			if player.superwait
				if player.mo.momz*P_MobjFlip(player.mo) <= FRACUNIT/2
					player.mo.momz = 0
					player.mo.spriteyoffset = FixedMul(5*FRACUNIT, cos((leveltime%360)*ANG2))
				end
				if player.speed > player.runspeed/3
					player.mo.spriteyoffset = 0
					player.mo.state = S_PLAY_FALL
					player.superwait = false
					player.supertimer = 0
					player.usespring = false
				else
					if player.mo.state != S_PLAY_FLOAT
						player.mo.state = S_PLAY_FLOAT
					end
					player.pflags = $|PF_JUMPED|PF_THOKKED|PF_NOJUMPDAMAGE
					player.pflags = $&~PF_SPINNING
					player.usespring = true
				end
			end
			player.wassuper = true
		else
			if player.wassuper
			and player.charflags & SF_SUPER
				player.charflags = $&~SF_SUPER
			end
			if player.superwait
				player.mo.spriteyoffset = 0
				player.mo.state = S_PLAY_FALL
				player.mo.frame = A
				player.mo.sprite2 = SPR2_PAIN
				player.mo.tics = TICRATE
				player.usespring = true
			end
			player.supertimer = 0
			player.superwait = false
			player.wassuper = false
		end
		
		player.supertransform = $ or 0
		if player.shieldbutton
		and player.cmd.buttons & player.shieldbutton
		and not (player.powers[pw_shield]&SH_NOSTACK)
		and not player.bashstate
			if not player.soup
			and All7Emeralds(emeralds)
			and player.rings >= 50
				if not player.powers[pw_super]
					S_ChangeMusic("UNDFSN", true, player)
					player.charflags = $|SF_SUPER
					player.supered = true
					P_FlashPal(player, 0, 5)
					
					if P_IsLocalPlayer(player)
						local cama = R_PointToAngle(player.mo.x, player.mo.y) --Upper part
						local dx = P_ReturnThrustX(nil, cama, player.mo.radius/2)
						local dy = P_ReturnThrustY(nil, cama, player.mo.radius/2)
						local bar = P_SpawnMobjFromMobj(player.mo, dx, dy, player.height/2*3, MT_PARTICLE)
						bar.state = S_EPIC_UP
						bar.angle = cama+ANGLE_90
						bar.spritexscale = FRACUNIT*3
						bar.spriteyscale = FRACUNIT*3
						
						local ax = P_ReturnThrustX(nil, cama, -player.mo.radius/2*3) --Bottom part
						local ay = P_ReturnThrustY(nil, cama, -player.mo.radius/2*3)
						local bar = P_SpawnMobjFromMobj(player.mo, ax, ay, 0, MT_PARTICLE)
						bar.state = S_EPIC_DOWN
						bar.angle = cama+ANGLE_90
						bar.spritexscale = FRACUNIT*3
						bar.spriteyscale = FRACUNIT*3
						
						local bx = P_ReturnThrustX(nil, cama, -player.mo.radius*5) --Floor part
						local by = P_ReturnThrustY(nil, cama, -player.mo.radius*5)
						local bar = P_SpawnMobjFromMobj(player.mo, bx, by, FRACUNIT, MT_PARTICLE)
						bar.state = S_EPIC_DOWN
						bar.flags2 = $|MF2_SPLAT
						bar.renderflags = $|RF_NOSPLATBILLBOARD
						bar.angle = cama
						bar.spritexscale = FRACUNIT*3
						bar.spriteyscale = FRACUNIT*10
						
						local camd = R_PointToAngle(player.mo.x, player.mo.y)-(ANG10)
						local px = P_ReturnThrustX(nil, camd+ANGLE_90, 50*FRACUNIT)
						local py = P_ReturnThrustX(nil, camd+ANGLE_90, 50*FRACUNIT)
						local cx = P_ReturnThrustX(nil, camd, -100*FRACUNIT)+px
						local cy = P_ReturnThrustY(nil, camd, -100*FRACUNIT)+py
						local cam = P_SpawnMobjFromMobj(player.mo, cx, cy, player.height/3*2, MT_PARTICLE)
						cam.tics = TICRATE
						cam.fuse = TICRATE
						cam.flags2 = $|MF2_DONTDRAW
						cam.angle = R_PointToAngle2(cam.x, cam.y, player.mo.x, player.mo.y)
						player.awayviewmobj = cam
						player.awayviewtics = TICRATE
						player.awayviewaiming = 0
					end
					
					P_DoSuperTransformation(player)
				end	
			end
			player.soup = true
		else
			player.soup = false
		end
		
		player.fadeout = $ or 0
		if player.fadeout
			player.fadeout = $-1
			player.goback = true
		elseif player.goback
			player.goback = false
			P_RestoreMusic(player)
			S_FadeMusic(0, 1, player)
			S_FadeMusic(100, MUSICRATE, player)
		end
		if player.powers[pw_super]
		and not player.hyper
			if not player.wassuper
				S_ChangeMusic("UNDFSN", true, player)
			end
			player.wassuper = true
		else
			if player.wassuper
				S_FadeMusic(0, MUSICRATE, player)
				player.fadeout = TICRATE
			end
			player.wassuper = false
		end
	end
end)