//No need for much commenting.

rawset(_G, "TN_EnemyCarry", {})
--type = carry type:

--none - doesnt do anything.
--heavy - slows tails down but when dropped makes an earthquake.
--speed - speeds tails down when dropped, instead thrown.
--turret - sometimer shoots a projectile at nearest enemies.
--bomber - when above an enemy drops a projectile.
--damage - when grabbed damages tails
--spring - when grabbed both, the tails and enemy go away.
--nopick - dont pick up the object


--var = parameter for the carry type.

--heavy - multiplier for earthquake range (500 * var)
--speed - speed multiplier (normalspd * var)
--turret - cooldown (proj type = var)
--bomber - height at which drops (diff < var)
--damage - stun (0 = false, 1 = true), if less than 0 then its a chance
--spring - how far away to spring

//Unused
--when landing these are saved in your 2 slot inventory.
--to open it press c1 mid-air, and press c1 again to switch.
--if menu is open and started flying tails will get the chosen enemy.

//Bosses
TN_EnemyCarry[MT_FANG] = {type = nil, var = FRACUNIT} --ACZ

//Recent Tails`s objects
TN_EnemyCarry[MT_WINDBALL] = {type = "speed", var = FRACUNIT}

//Crawlas
TN_EnemyCarry[MT_BLUECRAWLA] = {type = "heavy", var = FRACUNIT} --GFZ
TN_EnemyCarry[MT_REDCRAWLA] = {type = "heavy", var = FRACUNIT*2} --GFZ
TN_EnemyCarry[MT_CRAWLACOMMANDER] = {type = "heavy", var = FRACUNIT/2*5} --THZ Legacy

//Springshells
TN_EnemyCarry[MT_SPRINGSHELL] = {type = "spring", var = 0} --THZ
TN_EnemyCarry[MT_YELLOWSHELL] = {type = "spring", var = 0} --Mods

//Fish
TN_EnemyCarry[MT_GFZFISH] = {type = "heavy", var = FRACUNIT/2*3} --THZ
TN_EnemyCarry[MT_JETJAW] = {type = "speed", var = FRACUNIT/4*5} --DSZ

//Buzzes
TN_EnemyCarry[MT_GOLDBUZZ] = {type = "speed", var = FRACUNIT/2*3} --THZ
TN_EnemyCarry[MT_REDBUZZ] = {type = "speed", var = FRACUNIT*2} --THZ

//Jetty-syns
TN_EnemyCarry[MT_JETTGUNNER] = {type = "turret", var = MT_JETTBULLET} --ERZ
TN_EnemyCarry[MT_JETTBOMBER] = {type = "bomber", var = MT_MINE} --ERZ

//Turrets
TN_EnemyCarry[MT_TURRET] = {type = "turret", var = MT_TURRETLASER} --THZ
TN_EnemyCarry[MT_POPUPTURRET] = {type = "turret", var = MT_JETTBULLET} --ERZ

//Misc
TN_EnemyCarry[MT_DETON] = {type = "nopick", var = 0} --THZ
TN_EnemyCarry[MT_SKIM] = {type = "bomber", var = MT_MINE} --DSZ
TN_EnemyCarry[MT_SPINCUSHION] = {type = "speed", var = FRACUNIT/2*3} --ERZ
TN_EnemyCarry[MT_SNAILER] = {type = "nopick", var = 0} --ERZ
TN_EnemyCarry[MT_POINTY] = {type = "damage", var = 1} --Mods
TN_EnemyCarry[MT_ROBOHOOD] = {type = "turret", var = MT_ARROW} --CEZ
TN_EnemyCarry[MT_FACESTABBER] = {type = "heavy", var = FRACUNIT*3} --CEZ
TN_EnemyCarry[MT_EGGGUARD] = {type = "spring", var = FRACUNIT} --CEZ
TN_EnemyCarry[MT_GSNAPPER] = {type = "damage", var = -FRACUNIT/50} --ACZ
TN_EnemyCarry[MT_CANARIVORE] = {type = "bomber", var = MT_CANARIVORE_GAS} --ACZ
TN_EnemyCarry[MT_PYREFLY] = {type = "none", var = 0} --RVZ
TN_EnemyCarry[MT_TNTBARREL] = {type = "heavy", var = FRACUNIT/4*3}

//Balls
TN_EnemyCarry[MT_MINUS] = {type = "damage", var = 0} --ACZ
TN_EnemyCarry[MT_UNIDUS] = {type = "heavy", var = FRACUNIT/3*2} --RVZ

//Birds
TN_EnemyCarry[MT_PTERABYTE] = {type = "speed", var = FRACUNIT/3*5} --RVZ
TN_EnemyCarry[MT_VULTURE] = {type = "speed", var = FRACUNIT/2*5} --ACZ

//Crushstacean
TN_EnemyCarry[MT_CRUSHSTACEAN] = {type = "turret", var = MT_CRUSHCLAW} --DSZ
TN_EnemyCarry[MT_BANPYURA] = {type = "spring", var = 0} --Mods

//Dragon bomber
TN_EnemyCarry[MT_DRAGONBOMBER] = {type = "heavy", var = FRACUNIT*5} --RVZ
TN_EnemyCarry[MT_DRAGONWING] = {type = "none", var = 0}
TN_EnemyCarry[MT_DRAGONTAIL] = {type = "heavy", var = FRACUNIT*4}
TN_EnemyCarry[MT_DRAGONMINE] = {type = "damage", var = 1}

//Monitors
TN_EnemyCarry[MT_RING_BOX] = {type = "heavy", var = FRACUNIT}
	--SRB2 Shields
	TN_EnemyCarry[MT_PITY_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ATTRACT_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_FORCE_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ARMAGEDDON_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_WHIRLWIND_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ELEMENTAL_BOX] = {type = "heavy", var = FRACUNIT}
	
	--SRB2 Power-ups
	TN_EnemyCarry[MT_SNEAKERS_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_INVULN_BOX] = {type = "heavy", var = FRACUNIT}
	
TN_EnemyCarry[MT_1UP_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_EGGMAN_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_MIXUP_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_MYSTERY_BOX] = {type = "heavy", var = P_RandomRange((FRACUNIT/2)>>FRACBITS, (FRACUNIT*2)>>FRACBITS)<<FRACBITS}
TN_EnemyCarry[MT_GRAVITY_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_RECYCLER_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_SCORE1K_BOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_SCORE10K_BOX] = {type = "heavy", var = FRACUNIT}
	--S3&K Shields
	TN_EnemyCarry[MT_FLAMEAURA_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_BUBBLEWRAP_BOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_THUNDERCOIN_BOX] = {type = "heavy", var = FRACUNIT}

	--CTF Ring monitors
	TN_EnemyCarry[MT_RING_REDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_RING_BLUEBOX] = {type = "heavy", var = FRACUNIT}


//Monitors (Gold, Respawning)
	--SRB2 Shields
	TN_EnemyCarry[MT_PITY_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ATTRACT_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_FORCE_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ARMAGEDDON_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_WHIRLWIND_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_ELEMENTAL_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	
	--SRB2 Power-ups
	TN_EnemyCarry[MT_SNEAKERS_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_INVULN_GOLDBOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_EGGMAN_GOLDBOX] = {type = "heavy", var = FRACUNIT}
TN_EnemyCarry[MT_GRAVITY_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	--S3&K Shields
	TN_EnemyCarry[MT_FLAMEAURA_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_BUBBLEWRAP_GOLDBOX] = {type = "heavy", var = FRACUNIT}
	TN_EnemyCarry[MT_THUNDERCOIN_GOLDBOX] = {type = "heavy", var = FRACUNIT}